require_relative '../lib/try-catch/memory'
require_relative '../lib/try-catch/functions'
require_relative '../lib/try-catch/syntax'

module TestA
  class << self

    def hello
      "hello world"
    end

    def complex
      "complex"
    end

  end
end


module TestB
  class << self

    def hello
      "hello world"
    end

    def complex hello
      "complex: #{hello.to_s}"
    end

  end
end


module TestC
  class << self

    def method_missing method_name, *args
      return __try_nil__{ ::TestA.__send__(method_name,*args) } || __try_nil__{ ::TestB.__send__(method_name,*args) }
    end

  end
end

puts TestC.hello
puts TestC.complex
puts TestC.complex "sup!"

=begin

hello world
complex
complex: sup!

=end